use clap::Parser;
// use sp1_sdk::{utils, ProverClient, SP1Stdin};
use hex;
use mtcs_garage::{AuthCert, Cert, MembershipProof, Obligation};

// const ELF: &[u8] = include_bytes!("../elf/riscv32im-succinct-zkvm-elf");

#[derive(Parser, Debug)]
#[command(version, about, long_about = None)]
struct Args {
    #[arg(short, long)]
    secret: String,

    #[arg(short, long)]
    from: String,

    #[arg(short, long)]
    to: String,

    #[arg(short, long)]
    value: u32,

    // #[arg(short, long)]
    // cache: String,
}

fn main() {
    let args = Args::parse();
    let (from, to) = (
        hex::decode(args.from).unwrap().try_into().unwrap(),
        hex::decode(args.to).unwrap().try_into().unwrap(),
    );

    let obligation = Obligation { from, to, value: args.value };
    let cert = Cert {
        subject: obligation,
        authenticity: AuthCert::from_secret(
            &obligation,
            &hex::decode(args.secret).unwrap().try_into().unwrap(),
        ),
        hash: [0; 32],
        salt: [0; 32],
        membership: MembershipProof::new(vec![from, to])
    };

    // utils::setup_tracer();
    
    // let mut stdin = SP1Stdin::new();
    // stdin.write(&cert.zkvm_serialize());
    // let client = ProverClient::new();
    // let (pk, vk) = client.prover.setup(ELF);
    // let proof = client.prove(&pk, stdin);
    // match proof {
    //     Ok(p) => println!("coool"),
    //     Err(_) => println!("not cool"),
    // }
}

// fn main() {

//     let nodes = rand::thread_rng().gen_range(0..100);
//     let o = rand_obligation();
//     let mp = MembershipProof::new(
//         std::iter::from_fn(|| Some(make_address()))
//             .take(nodes)
//             .collect(),
//     );
//     let c = Cert {
//         subject: o.o,
//         authenticity: AuthCert {
//             subject: o.o,
//             signature: rand::random(),
//         },
//         membership: mp,
//         salt: rand::random(),
//         hash: rand::random(),
//     };


//     utils::setup_tracer();
//     let mut stdin = SP1Stdin::new();

    
//     stdin.write(&data_str);
//     stdin.write(&key);
//     stdin.write(&initial_account_state);
//     stdin.write(&transactions);

//     let mut proof = SP1Prover::prove(JSON_ELF, stdin).expect("proving failed");

//     // Read output.
//     let val = proof.stdout.read::<String>();
//     println!("Value of {} is {}", key, val);

//     let account_state = proof.stdout.read::<Account>();
//     println!(
//         "Final account state: {}",
//         serde_json::to_string(&account_state).unwrap()
//     );

//     // Verify proof.
//     SP1Verifier::verify(JSON_ELF, &proof).expect("verification failed");

//     // Save proof.
//     proof
//         .save("proof-with-io.json")
//         .expect("saving proof failed");

//     println!("successfully generated and verified proof for the program!")
// }
